%global forgeurl https://github.com/cbeuw/Cloak
%global version 2.10.0
%global commit 7f9c17439fc1510fb54f5bffcd12547624550422
%global date 20250430
%global gomodulesmode GO111MODULE=on
%global source_date_epoch_from_changelog 0
%global _enable_debug_packages 0
%forgemeta

Name: cloak
Version: %{forgeversion}
Release: %{autorelease}
Summary: Cloak obfuscating proxy
License: GPL-3.0-only
URL: %{forgeurl}
Source0: %{forgesource}
Source1: %{name}@.service
Source2: %{name}.howto
BuildRequires: git-core
BuildRequires: golang-bin
BuildRequires: go-rpm-macros
BuildRequires: systemd-rpm-macros

%description
Cloak is an obfuscating proxy solution.
It allows to circumvent censorship and data discrimination.

%prep
%forgesetup
for CMD in client server
do %__sed -e "s/{CMD}/${CMD}/g" %{SOURCE1} > %{name}-${CMD}@.service
done

%build
export GOPROXY="https://proxy.golang.org,direct"
export GOFLAGS="-trimpath"
export GO_LDFLAGS="-s -w"
for CMD in client server
do %gobuild -o %{name}-${CMD} ./cmd/ck-${CMD}
done

%install
for CMD in client server
do
%__install -p -d -m 755 %{buildroot}%{_sysconfdir}/%{name}/${CMD}
%__install -p -D -m 644 -t %{buildroot}%{_unitdir} %{name}-${CMD}@.service
%__install -p -D -m 755 -t %{buildroot}%{_bindir} %{name}-${CMD}
%__install -p -D -m 644 -t %{buildroot}%{_pkgdocdir}/examples \
example_config/ck${CMD}.json
done
%__install -p -D -m 644 -t %{buildroot}%{_pkgdocdir} %{SOURCE2} README.md

%post
for UNIT in $(systemctl -P Id show %{name}-\*.service)
do %systemd_post ${UNIT}
done

%preun
for UNIT in $(systemctl -P Id show %{name}-\*.service)
do %systemd_preun ${UNIT}
done

%postun
for UNIT in $(systemctl -P Id show %{name}-\*.service)
do %systemd_postun_with_restart ${UNIT}
done

%files
%license LICENSE
%doc %{_pkgdocdir}
%{_sysconfdir}/*
%{_unitdir}/*
%{_bindir}/*
